# 5.2.2

Release date: `2021-06-21`

## Core

- [NXDRIVE-1995](https://jira.nuxeo.com/browse/NXDRIVE-1995): Display a proper message when no application associated to a given file type
- [NXDRIVE-2218](https://jira.nuxeo.com/browse/NXDRIVE-2218): Introduce (database) migrations objects
- [NXDRIVE-2548](https://jira.nuxeo.com/browse/NXDRIVE-2548): Databases refactoring
- [NXDRIVE-2640](https://jira.nuxeo.com/browse/NXDRIVE-2640): [Windows] Remote deletions are not locally impacted when the local folder is a UNC name
- [NXDRIVE-2654](https://jira.nuxeo.com/browse/NXDRIVE-2654): Remove the `execution.profile` custom metric
- [NXDRIVE-2656](https://jira.nuxeo.com/browse/NXDRIVE-2656): Improve crash file handling
- [NXDRIVE-2657](https://jira.nuxeo.com/browse/NXDRIVE-2657): Fix database `is_healthy()` check to ensure to close the connection
- [NXDRIVE-2659](https://jira.nuxeo.com/browse/NXDRIVE-2659): [macOS] Handle unsupported command `nxdrive://trigger-watch` in protocol handler
- [NXDRIVE-2661](https://jira.nuxeo.com/browse/NXDRIVE-2661): Set a higher logging level for `Options` changes
- [NXDRIVE-2664](https://jira.nuxeo.com/browse/NXDRIVE-2664): Add custom metrics for features state
- [NXDRIVE-2670](https://jira.nuxeo.com/browse/NXDRIVE-2670): Ignore "start on boot" option setter errors
- [NXDRIVE-2673](https://jira.nuxeo.com/browse/NXDRIVE-2673): Add custom metrics for the upload provider
- [NXDRIVE-2676](https://jira.nuxeo.com/browse/NXDRIVE-2676): Do not retry to send asynchronous metrics on error
- [NXDRIVE-2682](https://jira.nuxeo.com/browse/NXDRIVE-2682): Fix mypy issues following the update to mypy 0.901
- [NXDRIVE-2683](https://jira.nuxeo.com/browse/NXDRIVE-2683): Ignore incomplete custom protocol URL token requests
- [NXDRIVE-2684](https://jira.nuxeo.com/browse/NXDRIVE-2684): [macOS] Fix opened documents retrieval not interating-safe
- [NXDRIVE-2686](https://jira.nuxeo.com/browse/NXDRIVE-2686): Fix backward compatibility checks handling the synchronization feature
- [NXDRIVE-2687](https://jira.nuxeo.com/browse/NXDRIVE-2687): Fix new errors found by codespell 2.1.0
- [NXDRIVE-2698](https://jira.nuxeo.com/browse/NXDRIVE-2698): Specify the UFT-8 encoding when reading/writing text files
- [NXDRIVE-2700](https://jira.nuxeo.com/browse/NXDRIVE-2700): Prevent `Comparison between bytes and string` warning
- [NXDRIVE-2701](https://jira.nuxeo.com/browse/NXDRIVE-2701): Lower logging level of unknown connection error

### Direct Edit

- [NXDRIVE-2142](https://jira.nuxeo.com/browse/NXDRIVE-2142): Sanitize the filename
- [NXDRIVE-2658](https://jira.nuxeo.com/browse/NXDRIVE-2658): Handle invalid data returned by the server when retrieving file infos
- [NXDRIVE-2681](https://jira.nuxeo.com/browse/NXDRIVE-2681): Handle HTTP 502 (Bad Gateway), 503 (Service Unavailable) and 504 (Gateway Time-out) errors during unlock

### Direct Transfer

- [NXDRIVE-2321](https://jira.nuxeo.com/browse/NXDRIVE-2321): Fix file name escaping when checking for document existence on the server
- [NXDRIVE-2665](https://jira.nuxeo.com/browse/NXDRIVE-2665): Rename "Options" to "Advanced"
- [NXDRIVE-2677](https://jira.nuxeo.com/browse/NXDRIVE-2677): Add custom metrics about the uploaded file
- [NXDRIVE-2679](https://jira.nuxeo.com/browse/NXDRIVE-2679): Add custom metrics about session items

## GUI

- [NXDRIVE-2634](https://jira.nuxeo.com/browse/NXDRIVE-2634): Improve behavior on Add account screen
- [NXDRIVE-2675](https://jira.nuxeo.com/browse/NXDRIVE-2675): Show the device ID on the About tab
- [NXDRIVE-2678](https://jira.nuxeo.com/browse/NXDRIVE-2678): Sentry enablement as an option

## Packaging / Build

- [NXDRIVE-2505](https://jira.nuxeo.com/browse/NXDRIVE-2505): Move the release process from Travis-CI to GitHub Actions
- [NXDRIVE-2697](https://jira.nuxeo.com/browse/NXDRIVE-2697): [GNU/Linux] Update AppImage tools

## Tests

- [NXDRIVE-2685](https://jira.nuxeo.com/browse/NXDRIVE-2685): [Windows] Create setup dev env BAT script
- [NXDRIVE-2688](https://jira.nuxeo.com/browse/NXDRIVE-2688): Add virtual environment facilities to deploy scripts
- [NXDRIVE-2689](https://jira.nuxeo.com/browse/NXDRIVE-2689): Fix `test_wrong_server_reply()`
- [NXDRIVE-2691](https://jira.nuxeo.com/browse/NXDRIVE-2691): Use proper job names in GitHub workflows

## Minor Changes

- Upgraded `authlib` from 0.15.3 to 0.15.4
- Upgraded `certifi` from 2020.12.5 to 2021.5.30
- Upgraded `nuxeo` from 6.0.1 to 6.0.2
- Upgraded `pefile` from 2021.5.13 to 2021.5.24
- Upgraded `pyobjc-core` from 7.2 to 7.3
- Upgraded `pyobjc-framework-cocoa` from 7.2 to 7.3
- Upgraded `pyobjc-framework-coreservices` from 7.2 to 7.3
- Upgraded `pyobjc-framework-fsevents` from 7.2 to 7.3
- Upgraded `pyobjc-framework-scriptingbridge` from 7.2 to 7.3
- Upgraded `pyobjc-framework-systemconfiguration` from 7.2 to 7.3
- Upgraded `pywin32` from 300 to 301
- Upgraded `tld` from 0.12.5 to 0.12.6
- Upgraded `urllib3` from 1.26.4 to 1.26.5

## Technical Changes

- Chanded `Engine.use_trash()`: it is no more a static method
- Added `LocalClientMixin.can_use_trash()`
- Added `Manager.reload_client_global_headers()`
- Added `Manager.set_sentry()`
- Added `Manager.use_sentry()`
- Removed `Options.exec_profile`
- Added `Remote.custom_global_metrics`
- Added `Remote.escape()`
- Added `Remote.reload_global_headers()`
- Added dao/adapters.py
- Renamed dao/base.py::`ConfigurationDAO` to dao/base.py::`BaseDAO`
- Added dao/migrations
- Moved dao/sqlite.py::`EngineDAO` to dao/engine.py::`EngineDAO`
- Moved dao/sqlite.py::`ManagerDAO` to dao/manager.py::`ManagerDAO`
- Moved dao/sqlite.py::`register_adapter` to dao/\_\_init\_\_.py::`register_adapter`
- Moved dao/sqlite.py::`SCHEMA_VERSION` to dao/\_\_init\_\_.py::`SCHEMA_VERSION`
- Renamed dao/sqlite.py to dao/base.py
- Moved engine/dao to dao
- Added exceptions.py::`NoAssociatedSoftware`
- Added metrics/constants.py::`DT_FILE_EXTENSION`
- Added metrics/constants.py::`DT_FILE_MIMETYPE`
- Added metrics/constants.py::`DT_FILE_SIZE`
- Added metrics/constants.py::`DT_SESSION_FILE_COUNT`
- Added metrics/constants.py::`DT_SESSION_FOLDER_COUNT`
- Added metrics/constants.py::`DT_SESSION_ITEM_COUNT`
- Added metrics/constants.py::`UPLOAD_PROVIDER`
- Removed metrics/constants.py::`EXEC_PROFILE`
- Added utils.py::`path_is_unc_name()`
